#version 440 core
layout(local_size_x = LOCAL_SIZE, local_size_y = 1) in;

shared float sharedMem[SHARED_MEM_SIZE];

layout(binding = 2, std430) buffer resultBuffer
{
	float result;
};

void main()
{
    uint threadIndex = gl_LocalInvocationID.x;

    int rep = 0;
    for(rep; rep < 10000; ++rep){
        uint d = SHARED_MEM_SIZE / 2;
        while (d > 0) {
            if (threadIndex < d)
                sharedMem[threadIndex] = sharedMem[threadIndex] + sharedMem[d + threadIndex];
            barrier();
            d /= 2;
        }
    }
    result = sharedMem[0]; //broadcast
}